
/**
 * Write a description of class Stack here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Stack<Tipo>
{
    private StackNode<Tipo> head = null;

    /**
     * inserta un elemento en el stack
     */ 
    public  void push(Tipo dato) {
        // crea un nuevo nodo y lo inserta delante del primero
        StackNode<Tipo> nodo = new StackNode<Tipo>(dato);
        nodo.setNext(head);
        head = nodo;
    }
    
    /**
     * pop - devuelve el último elemento insertado y lo quita
     * del stack
     */
    public Tipo pop() {
        if(!isEmpty()) {
            StackNode<Tipo> node = head;
            head = head.getNext();
            return node.getData();
        } else {
            return null;
        }
    } // end pop
    
    /**
     * peek - devuelve el último elemento insertado, pero 
     * sin quitarlo de la pila
     */
    public Tipo peek() {
        if(!isEmpty()) {
            return head.getData();
        } else 
            return null;    
    } // end peek
      
    /**
     * devuelve true si el stack está vacío
     */
    public boolean isEmpty() {
        return head == null;
    } // end isEmpty
}

class StackNode<Tipo>  {
    private Tipo data;
    private StackNode<Tipo> next;
   
    public StackNode(Tipo data) {
        this.data = data;
    }
    
    public void setNext(StackNode<Tipo> next) {
        this.next = next;
    }
    
    public StackNode<Tipo> getNext() {
        return next;
    }
    
    public void setData(Tipo data) {
        this.data = data;
    }
    
    public Tipo getData() {
        return data;
    }
}
    
