
/**
 * Write a description of class TestArrayList here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
import java.util.Collections;
import java.util.Collection;
import java.util.ArrayList;

public class TestArrayList
{
    ArrayList<Persona> list = new ArrayList<Persona>();
    
    public TestArrayList() {
        Collections.addAll( list,
            new Persona("Max", 10),
            new Persona("Otto", 12),
            new Persona("Altea", 13)
        );
    }  // end TestArrayList

    public void printAll() {
        System.out.println(list);
    }
    
    public void printAll(String s) {
        System.out.println(s);
        printAll();
    }
    
    public void test() {
        printAll("\nElementos iniciales (usando Collections.addAll):");
        
        Persona[] adicionales = {
            new Persona("Pedro", 15),
            new Persona("Juan", 12),
            new Persona("Napoleón", 10)
        };
        
        Collections.addAll(list, adicionales);
        printAll("\nElementos después de haber añadido un array usando Collections.addAll");
        
        // buscamos Juan de 12 años y le sumamos uno a su edad
        int i;
        if( (i = list.indexOf(new Persona("Juan", 12))) != -1 ) {
            // recuperamos el objeto, cambiamos la edad, 
            // y lo devolvemos a la lista
            Persona p = list.get(i);
            p.setEdad(p.getEdad()+1);
            list.set(i, p);
            
            System.out.println("\nHemos sumado un año a la edad de Juan");
        }
        
        // ordenamos el arreglo
        Collections.sort(list);
        printAll("\nAhora los objetos ordenados por edad usando Collections.sort");
     
        // mezclamos los elementos al azar
        Collections.shuffle(list);
        printAll("\nElementos desordenados usando Collections.shuffle");
        Collections.shuffle(list);
        printAll();
    }
        
    public static void main(String[]args) {
        TestArrayList tal = new TestArrayList();
        tal.test();
        
    }  // end main
}