import java.util.ArrayList;
import java.util.Iterator;

public class TestArrayList1
{

    ArrayList<Persona> list = new ArrayList<Persona>();
    
    /**
     * Constructor
     */
    public TestArrayList1() {
        // Añadimos algunos elementos a la lista
        // add inserta siempre al final
        list.add( new Persona("Max", 10));
        list.add( new Persona("Otto", 12));
        list.add( new Persona("Altea", 13));
        
    }  // end TestArrayList1

    public void printAll() {
        System.out.print("[ ");
        // usamos un iterador para imprimir los objetos
        Iterator it = list.iterator();
        while(it.hasNext()) {
            System.out.print(it.next() + ", ");
        }
        System.out.println(" ]");
    }
    
    public void printAll(String s) {
        System.out.println(s);
        printAll();
    }
    
    public void printAllConFor() {
        System.out.print("[ ");
        for(Persona p: list) {
            System.out.print(p + ", ");
        }
        System.out.println(" ]");
        
    }
    
    public void printAllConFor(String s) {
        System.out.println(s);
        printAllConFor();
    }
    
    public void test() {
        printAll("\nElementos iniciales (usando add(element)):");
        
        list.add(1, new Persona("Pedro", 15));
        list.add(0, new Persona("Juan", 12));
        list.add(2, new Persona("Napoleón", 10));
        
        printAll("\nElementos añadidos usando add(i, element)");
        
        // buscamos Juan de 12 años y le sumamos uno a su edad
        int i;
        if( (i = list.indexOf(new Persona("Juan", 12))) != -1 ) {
            // recuperamos el objeto, cambiamos la edad, 
            // y lo devolvemos a la lista
            Persona p = list.get(i);
            p.setEdad(p.getEdad()+1);
            list.set(i, p);
            
            printAllConFor("\nHemos sumado un año a la edad de Juan, e imprimimos con printAllConFor()");
        }
        
    }
        
    public static void main(String[]args) {
        TestArrayList1 tal = new TestArrayList1();
        tal.test();
        
    }  // end main

}
