
/**
 * Write a description of class TestNodo here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class TestNodo
{
    
    public static void main(String[] args) {
        Nodo lista = null;
        // insertamos algunos objetos Persona en la lista
        // el primer nodo lo asignamos directamente a lista
        lista = new Nodo(new Persona("Juan","Pérez", 45));
        // el resto de nodos son insertados en la segunda posición
        lista.insertNodo(new Persona("José", "Pérez", 30));
        lista.insertNodo(new Persona("Juana", "Pérez", 28));
        lista.insertNodo(new Persona("Benjamín", "Pérez", 18));
        
        // imprimimos la lista
        System.out.println("--------------------");
        printList(lista);
        
        // ahora, vamos a borrar el *segundo* nodo:
        lista.deleteNodo();
        System.out.println("--------------------");
        printList(lista);
        
        // para acceder a los métodos de Persona, necesitamos
        // hacer un downcast (salvo que sean override de los
        // métodos de Object, en cuyo caso la llamada es polimórfica)
        // recuperamos la persona del segundo elemento de la lista
        Persona p = (Persona) lista.getNext().getData();
        System.out.println("Apellido: " + p.getApellido());
        
    }
    
     /**
     * imprime la lista desde el nodo list en adelante
     */
    public static void printList(Nodo list) {
        while(list != null) {
            // imprimimos el nodo.  getData devuelve un
            // Object, pero no necesitamos hacer un downcast:
            // toString (que es llamado por el println) 
            // está definido en Object, Persona hace
            // un override de toString.  Por tanto, la llamada al toString
            // de Object es polimórfica.
            System.out.println( list.getData() );
            // avanzamos al siguiente nodo
            list = list.getNext();
        }  // end while
    }
}
