
/**
 * Demuestra la diferencia entre hide y override.
 * Hide:  cuando se reemplaza un método estático (class method)
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Gato extends Animal {

    static String test;
    
    public Gato() {
        super();
        test = "Gato";
    }
    
    public static void metodoEstatico() {
        System.out.println("El método estático de Gato.");
    }
    
    public void noEstatico() {
        System.out.println("El método no estático de Gato.");
    }
    
    /**
     * método main que ejecuta el programa.  No tiene
     * que ver en la cuestión de hide.
     */
    public static void main(String[] args) {
        
        Gato gato = new Gato();
        Animal animal = gato;   // podemos decir esto porque todo gato es animal
                                // aunque no todo animal es gato.
        
        // Decir animal.metodoEstatico() es pésimo, porque hide() es un método
        // estático. Pero en este caso estamos diciendo animal.metodoEstatico
        // para hacer notar que aunque hemos dicho animal = gato
        // (y gato es de tipo Gato), animal.metodoEstatico() llama al método de la
        // clase Animal y no al de la clase Gato.
        System.out.println("Método estático:");
        animal.metodoEstatico();
        Gato.metodoEstatico();
     
        System.out.println("\ntest en Animal: " + animal.test);
        System.out.println("test en Gato: " + gato.test + "\n");
        // Aquí demostramos que el método noEstatico(), al no ser estático,
        // queda efectivamente reemplazado en la subclase gato:
        System.out.println("Método no estático:");
        animal.noEstatico();
        gato.noEstatico();
    
    }

}

